" Vim syntax file
" Language:	GNU Assembler
" Maintainer:	Kevin Dahlhausen <ap096@po.cwru.edu>
" Last change:	1997 April 20

" Remove any old syntax stuff hanging around
syn clear

syn case ignore

syn keyword edlConditional	do while if endif enddo then else until switch endswitch case break

syn match edlIdentifier		"[a-zA-Z_$#%@][a-zA-Z0-9_$#%@]*"
syn match edlLabel		"^[a-zA-Z_$#%@][a-zA-Z0-9_$#%@]*[ 	]"he=e-1
syn match edlString		"'[^']*'"

" Various #'s as defined by GAS ref manual sec 3.6.2.1
" Technically, the first decNumber def is actually octal,
" since the value of 0-7 octal is the same as 0-7 decimal,
" I prefer to map it as decimal:
syn match decNumber		"[0-9]\d*"
syn match decNumber		"\d*[fF]'\d*'"
syn match hexNumber		"[xX]'[0-9a-fA-F]'\+"
syn match edlChar		"[cC]'[^']*'\+"
syn match edlChar		"[cC][lL]\d*'[^']*'\+"

syn match edlComment		"^[*].*"

syn case match

if !exists("did_asm_syntax_inits")
  let did_asm_syntax_inits = 1

  " The default methods for highlighting.  Can be overridden later
  hi link edlLabel	Special
  hi link edlComment	Comment
  hi link edlChar	String
  hi link edlString	String
  hi link edlConditional Keyword

  hi link hexNumber	Number
  hi link decNumber	Number
  " hi Special term=reverse
endif

let b:current_syntax = "edl"

" vim: ts=8
